
#include <QWidget>
#include <QString>
#include <QStringList>
#include <QComboBox>
#include <QGridLayout>

#include "EngineeringUnits.h"
#include "enum.bactypes.h"

// This object needs to be fixed; BACnet put so many ridiculous units in here
// and they aren't ordered in any way.

EngineeringUnits::EngineeringUnits(QWidget *parent, int db_id, int PropId, QString label, QGridLayout *layout, int row, int col)
  : Enum(parent, db_id, PropId, label, layout, row, col) {
  SetList(QStringList()
    << "m^2" << "ft^2" << "mA" << "A" << "ohm"
    << "V" << "kV" << "MV" << "VA" << "kVA" << "mVA"
    << "VAR" << "kVAR" << "mVAR" << "deg (phase)"
    << "power factor" << "J" << "kJ" << "W-hr" << "kW-hr"
    << "btu" << "therm" << "ton-hr" << "J/kg (dry air)"
    << "btu/lb (dry air)" << "/hr" << "/min" << "hz"
    << "water g/kg (dry air)" << "%hum" << "mm" << "m"
    << "in" << "ft" << "W/ft^2" << "W/m^2" << "lum"
    << "lux" << "ft-cdl" << "kg" << "lb" << "ton"
    << "kg/s" << "kg/min" << "kg/hr" << "lb/min"
    << "lb/hr" << "W" << "kW" << "MW" << "btu/hr"
    << "hp" << "tons fridge." << "Pa" << "kPa" << "bar"
    << "lb/in^2" << "cm water" << "in water" << "mm mercury"
    << "cm mercury" << "in mercury" << "deg C" << "deg K"
    << "deg F" << "deg-day C" << "deg-day F" << "year"
    << "month" << "week" << "day" << "hr" << "min" << "s"
    << "m/s" << "km/hr" << "ft/s" << "ft/min" << "mph"
    << "f^3" << "m^3" << "gal" << "L" << "US gal"
    << "ft^3/min" << "m^3/s" << "gal/min" << "L/s"
    << "L/min" << "US gal/min" << "deg (angle)" << "degC/hr"
    << "degC/min" << "degF/hr" << "degF/min" << " " << "ppm"  // no units 95
    << "ppb" << "percent" << "%/s" << "/min" << "/s"
    << "psi/degF" << "rad" << "rpm" << "curr1" << "curr2"
    << "curr3" << "curr4" << "curr5" << "curr6" << "curr7"
    << "curr8" << "curr9" << "curr10" << "in^2" << "cm^2"
    << "btu/lb" << "cm" << "lb/s" << "delta degF" << "delta degK"
    << "kohm" << "mohm" << "mV" << "kJ/kg" << "MJ" << "J/degK"
    << "J/kg-degK" << "kHz" << "mHz" << "/hr" << "mW" << "hPa"
    << "mbar" << "m^3/hr" << "L/hr" << "kW-hr/m^2" << "kW-hr/ft^2"
    << "MJ/m^2" << "MJ/ft^2" << "W/m^2-degK" << "ft^3/s" << "%/ft"
    << "%/m", 95);
}

EngineeringUnits::EngineeringUnits(QWidget *parent, int db_id, int PropId, int value, QString label, QGridLayout *layout, int row, int col)
  : Enum(parent, db_id, PropId, label, layout, row, col) {
  SetList(QStringList()
    << "m^2" << "ft^2" << "mA" << "A" << "ohm"
    << "V" << "kV" << "MV" << "VA" << "kVA" << "mVA"
    << "VAR" << "kVAR" << "mVAR" << "deg (phase)"
    << "power factor" << "J" << "kJ" << "W-hr" << "kW-hr"
    << "btu" << "therm" << "ton-hr" << "J/kg (dry air)"
    << "btu/lb (dry air)" << "/hr" << "/min" << "/s"
    << "water g/kg (dry air)" << "%hum" << "mm" << "m"
    << "in" << "ft" << "W/ft^2" << "W/m^2" << "lum"
    << "lux" << "ft-cdl" << "kg" << "lb" << "ton"
    << "kg/s" << "kg/min" << "kg/hr" << "lb/min"
    << "lb/hr" << "W" << "kW" << "MW" << "btu/hr"
    << "hp" << "tons fridge." << "Pa" << "kPa" << "bar"
    << "lb/in^2" << "cm water" << "in water" << "mm mercury"
    << "cm mercury" << "in mercury" << "deg C" << "deg K"
    << "deg F" << "deg-day C" << "deg-day F" << "year"
    << "month" << "week" << "day" << "hr" << "min" << "s"
    << "m/s" << "km/hr" << "ft/s" << "ft/min" << "mph"
    << "f^3" << "m^3" << "gal" << "L" << "US gal"
    << "ft^3/min" << "m^3/s" << "gal/min" << "L/s"
    << "L/min" << "US gal/min" << "deg (angle)" << "degC/hr"
    << "degC/min" << "degF/hr" << "degF/min" << " " << "ppm"
    << "ppb" << "percent" << "%/s" << "/min" << "/s"
    << "psi/degF" << "rad" << "rpm" << "curr1" << "curr2"
    << "curr3" << "curr4" << "curr5" << "curr6" << "curr7"
    << "curr8" << "curr9" << "curr10" << "in^2" << "cm^2"
    << "btu/lb" << "cm" << "lb/s" << "delta degF" << "delta degK"
    << "kohm" << "mohm" << "mV" << "kJ/kg" << "MJ" << "J/degK"
    << "J/kg-degK" << "kHz" << "mHz" << "/hr" << "mW" << "hPa"
    << "mbar" << "m^3/hr" << "L/hr" << "kW-hr/m^2" << "kW-hr/ft^2"
    << "MJ/m^2" << "MJ/ft^2" << "W/m^2-degK" << "ft^3/s" << "%/ft"
    << "%/m", value);
}
